import IPOO.*;
import java.util.*;
import java.io.*;

public class Tester
{
    public static void main (String args[])
    {
        int errores = 0;
        
        System.out.print("Testing mode: (a)utomatic / (f)ile: ");
        char modo = ES.leerChar();
        while ((modo != 'a') && (modo != 'f')) {
            // Este ciclo asegura que solo se elegira una opcion valida
            System.out.print("Testing mode: (a)utomatic / (f)file: ");
            modo = ES.leerChar();
        }

        System.out.println("------------------------------------------");
        
        int CP=0;//Le asignamos valores por defecto para poder testear
        int poblacion=0;
        float superficie=0;
        Random gen = new Random();
        Ciudad ciudad;
        
        // Se obtienen los valores de testeo segun el modo elegido
        if (modo == 'a') {
            // Modo de testeo con valores automaticos
            CP = gen.nextInt(10000);
            poblacion = gen.nextInt(100000);
            superficie = gen.nextFloat() * 1000;

            System.out.println("VALORES ALEATORIOS GENERADOS");
            System.out.println("Codigo Postal: " + CP);
            System.out.println("Poblacion: " + poblacion);
            System.out.println("Superficie: " + superficie);            
        } else {
                    // Modo de testeo con valores ingresados desde archivo
                    
                   try{
                        BufferedReader bf= new BufferedReader(new FileReader("datos.txt")); //Se abre el archivo datos.txt en modo lectura 
                        String linea= bf.readLine();//lectura primer linea del archivo correspondiente al CP
                        CP= Integer.parseInt(linea);//conversion de string a entero
                        
                        linea=bf.readLine();// lectura segunda linea del archivo correspondiente a la poblacion
                        poblacion=Integer.parseInt(linea);
                        
                        linea=bf.readLine();// lectura segunda linea del archivo correspondiente a la superficie
                        superficie=Float.parseFloat(linea);
                        
                        System.out.println("VALORES DESDE ARCHIVO");
                        System.out.println("Codigo Postal: " + CP);
                        System.out.println("Poblacion: " + poblacion);
                        System.out.println("Superficie: " + superficie);   
                }
                    catch(Exception E)
                        {System.out.println("Se produjo un error con la lectura del archivo.");}
                              
        }
                
        System.out.println("------------------------------------------");
        
        // Se crea un objeto ciudad usando el constructor de un parametro
        System.out.println("TEST DE CONSTRUCTOR DE UN PARAMETRO Y COMANDOS 'ESTABLECER'");
        ciudad = new Ciudad(CP);
        ciudad.establecerPoblacion(poblacion);
        ciudad.establecerSuperficie(superficie);
        
        
        
        // Se testean las consultas triviales
        System.out.println("CONSULTAS TRIVIALES");
        int CP2 = ciudad.obtenerCP();
        int poblacion2 = ciudad.obtenerPoblacion();
        float superficie2 = ciudad.obtenerSuperficie();
        
        /**
         *  Completar tester de consultas triviales.
         *      obtenerCP
         *      obtenerPoblacion
         *      obtenerSuperficie
         *  
         *  Ejemplo:
         *      Para el método obtenerCP se debe chequear  si el valor que devuelve la consulta es igual al valor que se estableció anteriormente en el objeto.
         *      Si los valores son distintos se debe incrementar en 1 la variable que cuanta la cantidad de errores (errores). Tanto si hubo error como si no, se
         *      debe imprimir por pantalla el resultado del tester (OK/ERROR).
         *      
         *  Repetir el procedimiento para los tres métodos triviales.
         */
        
 
        
        System.out.println("------------------------------------------");
        
        // Se crea un objeto ciudad usando el constructor de tres parametros
        System.out.println("TEST DE CONSTRUCTOR DE TRES PARAMETROS");
        ciudad = new Ciudad(CP, poblacion, superficie);
        
        // Se testean las consultas triviales
        CP2 = ciudad.obtenerCP();
        poblacion2 = ciudad.obtenerPoblacion();
        superficie2 = ciudad.obtenerSuperficie();
        
        System.out.println("CONSULTAS TRIVIALES");
        System.out.print("Codigo Postal: " + CP2);
        if (CP == CP2) {
            System.out.println(" - OK");
        } else {
            System.out.println(" - ERROR");
            errores++;
        }
        System.out.print("Poblacion: " + poblacion2);
        if (poblacion == poblacion2) {
            System.out.println(" - OK");
        } else {
            System.out.println(" - ERROR");
            errores++;
        }
        System.out.print("Superficie: " + superficie2);
        if (superficie == superficie2) {
            System.out.println(" - OK");
        } else {
            System.out.println(" - ERROR");
            errores++;
        }  
        System.out.println("------------------------------------------");

        // Test de densidad
        System.out.println("TEST DE DENSIDAD");
        if (ciudad.obtenerSuperficie() == 0) {
            // No se puede obtener la densidad si la superficie de la ciudad es 0
            System.out.println("ERROR: No se puede obtener la densidad si la superficie de la ciudad es 0");
            errores++;
        } else {
            float densidad = ciudad.obtenerDensidad();
            System.out.println("Densidad: " + densidad);
        }
        System.out.println("------------------------------------------");
        
        // Test de incrementar poblacion
        System.out.println("TEST DE INCREMENTO DE POBLACION");
        int cre;
       
        System.out.print("Ingrese el valor de poblacion a incrementar (puede ser un valor negativo): ");
        cre = ES.leerEntero();
        
        
        poblacion = ciudad.obtenerPoblacion();
        System.out.println("Valor anterior de poblacion: " + poblacion);
        System.out.println("Sumando " + cre + " habitantes...");
        ciudad.aumentarPoblacion(cre);
        poblacion2 = ciudad.obtenerPoblacion();
        System.out.println("Nuevo valor poblacion: " + poblacion2);
        
        if (poblacion2 >= 0) {
            System.out.println("OK");
        } else {
            System.out.println("ERROR: Poblacion negativa");
            errores++;
        }
        System.out.println("------------------------------------------");
        
        // Test de incrementar poblacion 2
        System.out.println("TEST DE INCREMENTO DE POBLACION CON UN VALOR NEGATIVO MUY ALTO");
        int cre2 = -999999999;
        ciudad.aumentarPoblacion(cre2);
        poblacion = ciudad.obtenerPoblacion();
        System.out.println("Nuevo valor poblacion: " + poblacion);
        
        if (poblacion == 0) {
            System.out.println("OK");
        } else {
            System.out.println("ERROR: Poblacion negativa");
            errores++;
        }
        System.out.println("------------------------------------------");
        
        if (errores == 0) {
            System.out.println("TESTEO SIN ERRORES!");
        } else if (errores == 1) {
            System.out.println("SE HA REGISTRADO UN (1) ERROR");
        } else {
            System.out.println("SE HAN REGISTRADO " + errores + " ERRORES");
        }
    }
}
